//DEFINE SENSORS
#define TOUCH  					SENSOR_1
#define COLOR  					SENSOR_2
#define COLOR_VALUE    			IN_2
#define SONAR_REAR     			SENSOR_4
#define SONAR_REAR_VALUE  		IN_4
#define SONAR_FRONT       		SENSOR_3
#define SONAR_FRONT_VALUE 		IN_3

//DEFINE threshold
#define RNEAR_THRESHOLD  		20 
#define FNEAR_THRESHOLD  		35

#define RPREDATOR_THRESHOLD		150 
#define FPREDATOR_THRESHOLD		150 

//Tempo
#define TIMEOUT                 60000 
#define SYNCTIME                200
#define TEXTOUT                 1000

//Colori
#define BLACK                   1
#define BLUE                    2
#define GREEN                   3
#define YELLOW                  4
#define RED                     5
#define WHITE                   6
#define LIGHTBLACK              35

//Movimento
#define PPOWER		  			75 	
#define MAXPOWER          		75 
#define MTIME             		100
#define MCYCLE            		30
#define ROTATE45          		500
#define ROTATE90          		600
#define ROTATE135         		1300
#define ROTATE180         		1500
#define MPOWER		      		50
#define RIGHT		      		0
#define LEFT		      		1

//Segni
#define ROCK              		1
#define PAPER             		2
#define SCISSORS          		3
#define LIZARD            		4
#define SPOCK             		5

//Morra
#define ROBOTWIN	  			1
#define PLAYERWIN	      		2		
#define DRAW		      		3

//Connessioni BLuetooth
#define BT_CONN0          		0
#define BT_CONN		      		1
#define BT_CONN2	      		2

//Comandi Joystick
#define FORWARD           		1
#define BACKWARD          		2
#define TURNRIGHT         		3
#define TURNLEFT          		4
#define ROTATERIGHT       		5
#define ROTATELEFT        		6
#define BREAKALL          		7
#define ATTACK            		8

//Joystick
#define MINAXIS	          		30
#define MAXAXIS	          		70

//Modalita
#define QUICKMATCH        		1
#define SURVIVAL          		2
#define EXIT          	        4

//Esito partita
#define GAMEOVER          		1
#define NEXTROUND         		2
#define SCORE_THRESHOLD	        2
#define PLAYERROUND				1
#define ROBOTROUND				2
#define PLAYERGAME				3
#define ROBOTGAME				4

mutex sem;

//FUNZIONI JOYSTICK

//Menu
int FMenu(){
	int menu = 0;
	int mode;

	ClearScreen();

	//Robodroid
Robo:

	while(menu == 0){
		Wait(SYNCTIME);
		ClearScreen();
		TextOut(TEXTLINE_1, TEXTLINE_1, "Robodroid", DRAW_OPT_NORMAL);

		if(ButtonPressed(BTNEXIT, true)){
			//Shut Down the Robot
			menu = 1;

			//Exit
ShutDownTheRobot:

			ClearScreen();
			TextOut(TEXTLINE_1, TEXTLINE_1, "Exit" );

			while(menu == 1){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNEXIT, true)){
					menu = 0;
					goto Robo;
				}
				else if(ButtonPressed(BTNCENTER, true)){
					SendRemoteNumber(BT_CONN2,MAILBOX7,4);
					Wait(1000);
					SendRemoteBool(BT_CONN,MAILBOX9,true);
					Wait(1000);
					PowerDown();
				}
				else if(ButtonPressed(BTNRIGHT, true)||ButtonPressed(BTNLEFT, true)){

					//Cancel
Cancel:
					menu = 2;
					ClearScreen();
					TextOut(TEXTLINE_1, TEXTLINE_1, "Cancel" , DRAW_OPT_NORMAL);

					while(menu == 2){
						Wait(SYNCTIME);
						if(ButtonPressed(BTNCENTER, true)||ButtonPressed(BTNEXIT, true)){
							menu = 0;
							goto Robo;
						}
						else if(ButtonPressed(BTNRIGHT, true)||ButtonPressed(BTNLEFT, true)){
							menu = 1;
							goto ShutDownTheRobot;
						}
					}
				}
				else if(ButtonPressed(BTNEXIT, true)){
					menu = 0;
					goto Robo;
				}
			}
		}
		else if(ButtonPressed(BTNCENTER, true)){
			//Quick Match
			menu = 1;

			//Quick Match
Quick:
			ClearScreen();
			TextOut(TEXTLINE_1, TEXTLINE_1, "Quick Match  " , DRAW_OPT_NORMAL);

			while(menu == 1){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNCENTER, true)){
					//1 Player
					mode = QUICKMATCH;
					menu = 2;

					//Single Player
Player:
					ClearScreen();
					TextOut(TEXTLINE_1, TEXTLINE_1, "Single Player" , DRAW_OPT_NORMAL);

					while(menu == 2){
						Wait(SYNCTIME);
						if(ButtonPressed(BTNCENTER, true)){
							//Start 1 Player Robodroid
							menu = 4;
							SendRemoteNumber(BT_CONN2,MAILBOX7,QUICKMATCH); //Robodroid/QuickMatch/SinglePlayer


						}

						else if(ButtonPressed(BTNEXIT, true)){
							menu = 1;
							goto Quick;
						}
					}
				}
				else if(ButtonPressed(BTNRIGHT, true)||ButtonPressed(BTNLEFT, true)){
					//Surival Mode
					menu = 2;

					//Survival Mode
SurvivalMode:
					ClearScreen();
					TextOut(TEXTLINE_1, TEXTLINE_1, "Survival Mode" , DRAW_OPT_NORMAL);

					while(menu == 2){
						Wait(SYNCTIME);
						if(ButtonPressed(BTNCENTER, true)){
							//Start Survival Mode
							mode = SURVIVAL;
							menu = 4;
							SendRemoteNumber(BT_CONN2,MAILBOX7,SURVIVAL); //Robodroid/SurvivalMode

						}
						else if(ButtonPressed(BTNRIGHT, true)||ButtonPressed(BTNLEFT, true)){
							menu = 1;
							goto Quick;
						}
						else if(ButtonPressed(BTNEXIT, true)){
							menu = 0;
							goto Robo;
						}
					}
				}
				else if(ButtonPressed(BTNEXIT, true)){
					menu = 0;
					goto Robo;
				}

			}
		}

	}
	return mode;
}

//Scelta del giocatore
int PlayerChoice(){
	ClearScreen();
	int choice = ROCK;
	while(true){
		Wait(SYNCTIME);
		switch(choice){

		case ROCK:
			TextOut(0, 0, "Rock    ", DRAW_OPT_NORMAL);
			while(choice == ROCK){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNCENTER, true)){return ROCK;}
				else if(ButtonPressed(BTNRIGHT, true)){choice++;}
				else if(ButtonPressed(BTNLEFT, true)){choice=SPOCK;}

			}
			break;

		case PAPER:
			TextOut(0, 0, "Paper   ", DRAW_OPT_NORMAL);
			while(choice == PAPER){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNCENTER, true)){return PAPER;}
				else if(ButtonPressed(BTNRIGHT, true)){choice++;}
				else if(ButtonPressed(BTNLEFT, true)){choice--;}
			}
			break;

		case SCISSORS:
			TextOut(0, 0, "Scissors", DRAW_OPT_NORMAL);
			while(choice == SCISSORS){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNCENTER, true)){return SCISSORS;}
				else if(ButtonPressed(BTNRIGHT, true)){choice++;}
				else if(ButtonPressed(BTNLEFT, true)){choice--;}
			}
			break;

		case LIZARD:
			TextOut(0, 0, "Lizard  ", DRAW_OPT_NORMAL);
			while(choice == LIZARD){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNCENTER, true)){return LIZARD;}
				else if(ButtonPressed(BTNRIGHT, true)){choice++;}
				else if(ButtonPressed(BTNLEFT, true)){choice--;}
			}
			break;

		case SPOCK:
			TextOut(0, 0, "Spock   ", DRAW_OPT_NORMAL);
			while(choice == SPOCK){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNCENTER, true)){return SPOCK;}
				else if(ButtonPressed(BTNRIGHT, true)){choice=ROCK;}
				else if(ButtonPressed(BTNLEFT, true)){choice--;}
			}
			break;

		}
	}
}

//Mostra il punteggio del giocatore in modalit Sopravvivenza.
//
//Al termine della partita se la modalit  sopravvivenza stampa a schermo il numero di round consecutivi vinti dal giocatore.
sub PlayerScore(int mode, int playerscore){
	if(mode == SURVIVAL){
		ClearScreen();
		TextOut(TEXTLINE_1, TEXTLINE_1, "You last " + NumToStr(playerscore) + " rounds", DRAW_OPT_NORMAL);
		Wait(TEXTOUT);
	}
}//PlayerScore

//FUNZIONI ROBOT AUTONOMO

//Esito Carta, Forbici, Sasso, Lizard, Spock
bool RockPaperScissors(int robotchoice, int playerchoice, int &robotwin){
	
	//Scelta del robot autonomo
	switch(robotchoice){
	case ROCK:
		//Scelta del giocatore
		switch(playerchoice){
		case ROCK:
			robotwin = DRAW;
			break;

		case PAPER:
			robotwin = PLAYERWIN;
			break;

		case SCISSORS:
			robotwin = ROBOTWIN;
			break;

		case LIZARD:
			robotwin = ROBOTWIN;
			break;

		case SPOCK:
			robotwin = PLAYERWIN;
			break;
		}
		break;

	case PAPER:
		//Scelta del giocatore
		switch(playerchoice){
		case ROCK:
			robotwin = ROBOTWIN;
			break;

		case PAPER:
			robotwin = DRAW;
			break;

		case SCISSORS:
			robotwin = PLAYERWIN;
			break;

		case LIZARD:
			robotwin = PLAYERWIN;
			break;

		case SPOCK:
			robotwin = ROBOTWIN;
			break;
		}
		break;

	case SCISSORS:
		//Scelta del giocatore
		switch(playerchoice){
		case ROCK:
			robotwin = PLAYERWIN;
			break;

		case PAPER:
			robotwin = ROBOTWIN;
			break;

		case SCISSORS:
			robotwin = DRAW;
			break;

		case LIZARD:
			robotwin = ROBOTWIN;
			break;

		case SPOCK:
			robotwin = PLAYERWIN;
			break;
		}
		break;

	case LIZARD:
		//Scelta del giocatore
		switch(playerchoice){
		case ROCK:
			robotwin = PLAYERWIN;
			break;

		case PAPER:
			robotwin = ROBOTWIN;
			break;

		case SCISSORS:
			robotwin = PLAYERWIN;
			break;

		case LIZARD:
			robotwin = DRAW;
			break;

		case SPOCK:
			robotwin = ROBOTWIN;
			break;
		}
		break;

	case SPOCK:
		//Scelta del giocatore
		switch(playerchoice){
		case ROCK:
			robotwin = ROBOTWIN;
			break;

		case PAPER:
			robotwin = PLAYERWIN;
			break;

		case SCISSORS:
			robotwin = ROBOTWIN;
			break;

		case LIZARD:
			robotwin = PLAYERWIN;
			break;

		case SPOCK:
			robotwin = DRAW;
			break;
		}
		break;
	}

	return true;
}



//Comportamento del robot in modalita predatore.
sub Predator(int &i, int j, bool black, bool fus, bool rus){
	//Colore nero
	if(black){

		switch(j){

			//Gira a destra
		case RIGHT:
			Acquire(sem);
			Off(OUT_BC);
			OnRev(OUT_C, PPOWER);
			Wait(ROTATE135);
			Off(OUT_BC);
			OnFwd(OUT_BC, PPOWER);
			Wait(1000);
			Release(sem);
			break;

			//Gira a sinistra
		case LEFT:
			Acquire(sem);
			Off(OUT_BC);
			OnRev(OUT_B, PPOWER);
			Wait(ROTATE135);
			OnFwd(OUT_BC, PPOWER);
			Wait(1000);
			Release(sem);
			break;

		}
	}

	//Ultrasuoni sul fronte
	else if(fus){
		Acquire(sem);
		OnFwd(OUT_BC, PPOWER);
		Wait(MTIME);
		Release(sem);
	}

	//Ultrasuoni sul retro
	else if(rus) {

		switch(j){
			
			//Gira a destra
		case RIGHT:
			Acquire(sem);
			Off(OUT_BC);
			OnFwd(OUT_C, PPOWER);
			Wait(ROTATE180);
			Release(sem);
			break;
			
			//Gira a sinistra
		case LEFT:
			Acquire(sem);
			Off(OUT_BC);
			OnFwd(OUT_B, PPOWER);
			Wait(ROTATE180);
			Release(sem);
			break;
		}
	}
	//Pattern base
	else{
		ClearScreen();
		//Avanza
		if(0<=i && i<30){
			Acquire(sem);
			Off(OUT_BC);
			OnFwd(OUT_BC, PPOWER);
			Wait(MTIME);
			Release(sem);
			i++;
		}
		//Gira su se stesso in cerca della preda
		else if(30<=i && i<70){
			Acquire(sem);
			Off(OUT_BC);
			OnFwd(OUT_C, PPOWER);
			Wait(MTIME);
			Release(sem);
			i++;
		}
		else{
			Acquire(sem);
			Off(OUT_BC);
			OnFwd(OUT_C, PPOWER);
			Wait(MTIME);
			Release(sem);
			i=0;
		}

	}

}//Predator	

//Comportamento del robot in modalit preda-sasso
sub Rock(int &i, int j, bool black, bool fus, bool rus){

	//Colore nero e ultrasuoni sul retro
	if((black) && rus){
		Acquire(sem);
		Off(OUT_BC);
		Release(sem);
	}

	//Ultrasuoni sul fronte e sul retro
	else if(fus && rus){

		switch(j){
			//Gira a destra
		case RIGHT:
			Acquire(sem);
			Off(OUT_BC);
			OnFwd(OUT_C, MAXPOWER);
			Wait(ROTATE90);
			Release(sem);
			break;

			//Gira a sinistra
		case LEFT:
			Acquire(sem);
			Off(OUT_BC);
			OnFwd(OUT_B, MAXPOWER);
			Wait(ROTATE90);
			Release(sem);
			break;
		}

	}

	//Colore nero o ultrasuoni frontale
	else if(black||fus){


		switch(j){

			//Gira a destra
		case RIGHT:
			Acquire(sem);
			Off(OUT_BC);
			OnFwd(OUT_C, MAXPOWER);
			Wait(ROTATE180);
			Release(sem);
			break;

			//Gira a sinistra
		case LEFT:
			Acquire(sem);
			Off(OUT_BC);
			OnFwd(OUT_B, MAXPOWER);
			Wait(ROTATE180);
			Release(sem);
			break;
		}
	}

	//Ultrasuoni sul retro
	else if(rus){
		Acquire(sem);
		Off(OUT_BC);
		OnFwd(OUT_BC, MAXPOWER);

		Release(sem);
	}
	//Pattern base
	else{
		//Fermo
		Acquire(sem);
		Off(OUT_BC);
		Release(sem);
	}

}//Rock

//Comportamento del robot in modalit preda-carta
sub Paper(int &i, int j, bool black, bool fus, bool rus){
	if(rus){

		switch(j){
			//Gira a destra
		case RIGHT:
			Acquire(sem);
			Off(OUT_B);
			OnRev(OUT_C, MAXPOWER);
			Wait(ROTATE90);
			Release(sem);
			break;

			//Gira a sinistra
		case LEFT:
			Acquire(sem);
			Off(OUT_C);
			OnRev(OUT_B, MAXPOWER);
			Wait(ROTATE90);
			Release(sem);
			break;
		}
	}
	//Ultrasuoni frontale o colore nero
	else if(fus || black){

		switch(j){

			//Gira a destra
		case RIGHT:
			Acquire(sem);
			Off(OUT_B);
			OnRev(OUT_C, MAXPOWER);
			Wait(ROTATE180);
			Release(sem);
			break;

			//Gira a sinistra
		case LEFT:
			Acquire(sem);
			Off(OUT_C);
			OnRev(OUT_B, MAXPOWER);
			Wait(ROTATE180);
			Release(sem);
			break;

		}
	}
	//Pattern base
	else{
		if(i==0 || i==31 || i==62 || i==83){

			Acquire(sem);
			Off(OUT_B);
			OnFwd(OUT_C, MAXPOWER);
			Wait(ROTATE90);
			Release(sem);
			i++;
		}
		else if(0<i && i<31){

			Acquire(sem);
			//Off(OUT_BC);
			OnFwd(OUT_BC, MAXPOWER);
			Wait(MTIME);
			Release(sem);
			i++;
		}
		else if(31<i && i<62){

			Acquire(sem);
			//Off(OUT_BC);
			OnFwd(OUT_BC, MAXPOWER);
			Wait(MTIME);
			Release(sem);
			i++;
		}
		else if(62<i && i<83){

			Acquire(sem);
			//Off(OUT_BC);
			OnFwd(OUT_BC, MAXPOWER);
			Wait(MTIME);
			Release(sem);
			i++;
		}
		else if(83<i && i<103){

			Acquire(sem);
			//Off(OUT_BC);
			OnFwd(OUT_BC, MAXPOWER);
			Wait(MTIME);
			Release(sem);
			i++;
		}
		else if(i==103){
			i=0;
			Acquire(sem);
			//Off(OUT_BC);
			OnFwd(OUT_BC, MAXPOWER);
			Wait(MTIME);
			Release(sem);
		}


	}
}//Paper

//Comportamento del robot in modalit preda-forbici
sub Scissors(int &i, int j, bool black, bool fus, bool rus){
	//Ultrasuoni sul fronte e sul retro o colore nero e ultrasuoni sul retro
	if((fus && rus) || ((black) && rus)){

		switch(j){

			//Gira a destra
		case RIGHT:
			Acquire(sem);
			Off(OUT_B);
			OnRev(OUT_C, MAXPOWER);
			Wait(ROTATE90);
			Release(sem);
			break;

			//Gira a sinistra
		case LEFT:
			Acquire(sem);
			Off(OUT_C);
			OnRev(OUT_B, MAXPOWER);
			Wait(ROTATE90);
			Release(sem);
			break;
		}
	}
	//Ultrasuoni frontale o colore nero
	else if(fus || black){

		switch(j){

			//Gira a destra
		case RIGHT:
			Acquire(sem);
			Off(OUT_BC);
			OnRev(OUT_C, MAXPOWER);
			Wait(ROTATE135);
			Release(sem);
			break;

			//Gira a sinistra
		case LEFT:
			Acquire(sem);
			Off(OUT_BC);
			OnRev(OUT_B, MAXPOWER);
			Wait(ROTATE135);
			Release(sem);
			break;
		}

	}
	//Ultrasuoni sul retro
	else if(rus){

		switch(j){

			//Gira a destra
		case RIGHT:
			Acquire(sem);
			Off(OUT_B);
			OnRev(OUT_C, MAXPOWER);
			Wait(ROTATE45);
			Release(sem);
			break;

			//Gira a sinistra
		case LEFT:
			Acquire(sem);
			Off(OUT_C);
			OnRev(OUT_B, MAXPOWER);
			Wait(ROTATE45);
			Release(sem);
			break;
		}
	}
	//Pattern base
	else{
		//Avanti
		Acquire(sem);
		OnFwd(OUT_BC, MAXPOWER);
		Release(sem);

	}
}//Scissors

//Comportamento del robo in modali preda-Lizard
sub Lizard(int &i, int j, bool black, bool fus, bool rus){
	//Ultrasuoni sul fronte o ultrasuoni sul retro o colore nero
	if(fus || rus || black){

		switch(j){

			//Gira a destra
		case RIGHT:
			Acquire(sem);
			Off(OUT_B);
			OnRev(OUT_C, MAXPOWER);
			Wait(ROTATE90);
			Release(sem);
			break;

			//Gira a sinistra
		case LEFT:
			Acquire(sem);
			Off(OUT_C);
			OnRev(OUT_B, MAXPOWER);
			Wait(ROTATE90);
			Release(sem);
			break;
		}


	}
	//Pattern base
	else{

		if(i==0 || i==31){
			Acquire(sem);
			Off(OUT_B);
			OnFwd(OUT_C, MAXPOWER);
			Wait(ROTATE90);
			Release(sem);
			i++;
		}
		else if(i==62 || i==93){
			Acquire(sem);
			Off(OUT_C);
			OnFwd(OUT_B, MAXPOWER);
			Wait(ROTATE90);
			Release(sem);
			i++;
		}
		else if(0<i && i<31 || 31<i && i<62 || 62<i && i<93 || 93<i && i<122){
			Acquire(sem);
			//Off(OUT_BC);
			OnFwd(OUT_BC, MAXPOWER);
			Wait(MTIME);
			Release(sem);
			i++;
		}
		else if(i==122){
			Acquire(sem);
			//Off(OUT_BC);
			OnFwd(OUT_BC, MAXPOWER);
			Wait(MTIME);
			Release(sem);
			i=0;
		}

	}
}//Lizard

//Comportamento del robot in modalit preda-Spock
sub Spock(int s, int &i, int j, bool black, bool fus, bool rus){

	switch(s){

	case ROCK:
		Rock(i, j, black, fus, rus);
		break;

	case PAPER:
		Paper(i, j, black, fus, rus);
		break;

	case SCISSORS:
		Scissors(i, j, black, fus, rus);
		break;

	case LIZARD:
		Lizard(i, j, black, fus, rus);
		break;

	}
}//Spock

//Seleziona il comportamento del robot autonomo in modalit predatore
//in base alla scelta della fase "Morra".
sub Prey(int robotchoice, int s, int &i, int j, bool black, bool fus, bool rus){

	ClearScreen();

	switch(robotchoice){

	case ROCK:
		TextOut(0, 0, "Rock", DRAW_OPT_NORMAL);
		Rock(i, j, black, fus, rus);
		break;

	case PAPER:
		TextOut(0, 0, "Paper", DRAW_OPT_NORMAL);
		Paper(i, j, black, fus, rus);
		break;

	case SCISSORS:
		TextOut(0, 0, "Scissors", DRAW_OPT_NORMAL);
		Scissors(i, j, black, fus, rus);
		break;

	case LIZARD:
		TextOut(0, 0, "Lizard", DRAW_OPT_NORMAL);
		Lizard(i, j, black, fus, rus);
		break;

	case SPOCK:
		TextOut(0, 0, "Spock", DRAW_OPT_NORMAL);
		Spock(s, i , j , black, fus, rus);
		break;

	}

}//Prey

//Chiede la conferma dell'avvenuto riposizionamento dei robot.
//
//Attende che venga premuto il bottone centrale del robot.
bool Reposition(){
	ClearScreen();
	TextOut(0,20,"Riposizionare i", DRAW_OPT_NORMAL);
	TextOut(0,10,"robot e premere", DRAW_OPT_NORMAL);
	TextOut(0, 0,"il tasto centrale", DRAW_OPT_NORMAL);
	until(ButtonPressed(BTNCENTER, true)){}
	return true;
}//Reposition
